#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>

#define nn (512)

#include "inc_precision.h"

REAL a[nn][nn];       /** matrixes**/
REAL b[nn][nn];
REAL c[nn][nn];


int main()
{
  int k, i, j, ii, jj;
  REAL somma;
  float time1, time2, dub_time;

  printf("===============================\n");
  if(sizeof(a[1][1]) == sizeof(float))
    printf("single precision\n");
  else
    printf("double precision\n");
  printf("size %d \n",nn );
  printf("===============================\n");
  printf("Initialization \n");

  /* initialize matrix */
  time1 = clock();
  for (j = 0; j < nn; j++)
    {
    for (i = 0; i < nn; i++)
      {
      a[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      b[j][i] = ((REAL)rand())/((REAL)RAND_MAX);
      c[j][i] = 0.0L;		
      }
    }
  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("Time -----------------> %f \n", dub_time);

  time1 = clock();
       for (j = 0; j < nn; j++)
  for (k = 0; k < nn; k ++)
            for (i = 0; i < nn; i++)
                 c[i][j] = c[i][j] + a[i][k]*b[k][j];


  time2 = clock();
  dub_time = (time2 - time1)/(double) CLOCKS_PER_SEC;
  printf("===============================\n");
  printf("Time -----------------> %f \n", dub_time);
  printf("Mflops ----------------> %f \n", 
          2.0*nn*nn*nn/(1000*1000*dub_time));

  /* simple check */
  somma = 0.0L;
  for (i = 0; i < nn; i++)
     for (j = 0; j < nn; j++)
         somma = somma + c[i][j];
  printf("Check -------------> %f \n", somma);

   return 0;  
}
